[SIGNALS]
SIGQUIT - gracefully shutdown the server
SIGUSR2 - upgrade executable on the fly

[UPGRADING]
Upgrading cmogstored on-the-fly is possible since version 1.2.0.
The procedure is close to the one used by nginx users: send SIGUSR2
followed by SIGQUIT to the old process.  Use of SIGWINCH and SIGHUP
are currently not supported (but may be in the future).
Procedures for the nginx upgrade are documented here:
http://wiki.nginx.org/CommandLine#Upgrading_To_a_New_Binary_On_The_Fly

[ENVIRONMENT]
MOG_IOSTAT_CMD - command-line for invoking iostat(1).  This is used
by the sidechannel to report disk utilization to trackers.
Default: "iostat -dx 1 30"

See MALLOC TUNING for environment variables which may affect memory
usage.

[MALLOC TUNING]

malloc(3) implementations tuned for multithreading speed (and not memory
usage) may cause large amounts of metadata overhead in infrequently-used
arenas.  While cmogstored may use many threads for filesystem I/O,
cmogstored is designed to not be dependent on malloc(3) performance nor
scalability.

On GNU/Linux systems with glibc, we recommend setting MALLOC_ARENA_TEST
and MALLOC_ARENA_MAX to low numbers to limit the number arenas.  Setting
the value of each to 1 or 2 should be enough, even.

[REPORTING BUGS]
Only bug reports in plain-text email will be read.
You may also report bugs publically to the MogileFS mailing list
mogile@googlegroups.com.

[COPYRIGHT]
Copyright (C) 2012-2013, Eric Wong <normalperson@yhbt.net>.
License: GNU GPL version 3 or later <https://www.gnu.org/licenses/gpl.html>.
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.

[SEE ALSO]
cmogstored website: http://bogomips.org/cmogstored/README
You can learn more about MogileFS: http://mogilefs.org/

cmogstored source code is available via git:

	git clone git://bogomips.org/cmogstored.git
